#include <math.h>
#include <allegro.h>
#include <alleggl.h>

#include "tankit.h"
#include "models.c"
#include "texture.c"
#include "tankit.c"
#include "menus.h"

#include "joystick.c"

BITMAP *buffer;
DATAFILE *menu;
int white;





void load_controls()
{
	PACKFILE *f;
	int i;

	if ( exists("keyboard.cfg") )
	{
		f = pack_fopen( "keyboard.cfg", "pr");
		for ( i = 0; i < 4; i++ )
			pack_fread( &player[ i ], sizeof( PLAYERTYPE ), f );
		pack_fclose( f );

	}
}

void save_controls()
{
	PACKFILE *f;

	int i;
	f = pack_fopen( "keyboard.cfg", "pw" );
	for ( i = 0; i < 4; i++ )
		pack_fwrite( &player[ i ], sizeof( PLAYERTYPE ), f );
	pack_fclose( f );

}


void save_config( char *file )
{
	PACKFILE *f;

	f = pack_fopen( file, "pw" );
	pack_fwrite( &BOUNDRY_X, sizeof( int ), f );
	pack_fwrite( &BOUNDRY_Z, sizeof( int ), f );
	pack_fwrite( &NUM_TANKS, sizeof( int ), f );
	pack_fwrite( &TANK_SPEED, sizeof( float ), f );
	pack_fwrite( &ROTATE_SPEED, sizeof( float ), f );
	pack_fwrite( &TANK_FIRE, sizeof( int ), f );
	pack_fwrite( &TANK_LIFE, sizeof( int ), f );
	pack_fwrite( &HUMAN_TANK_LIFE, sizeof( int ), f );
	pack_fwrite( &BULLET_LIFE, sizeof( int ), f );
	pack_fwrite( &BULLET_SPEED, sizeof( float ), f );
	pack_fwrite( &NUM_TREES, sizeof( int ), f );

	pack_fclose( f );
}

void load_config( char *file )
{
	PACKFILE *f;

	f = pack_fopen( file, "pr" );
	pack_fread( &BOUNDRY_X, sizeof( int ), f );
	pack_fread( &BOUNDRY_Z, sizeof( int ), f );
	pack_fread( &NUM_TANKS, sizeof( int ), f );
	pack_fread( &TANK_SPEED, sizeof( float ), f );
	pack_fread( &ROTATE_SPEED, sizeof( float ), f );
	pack_fread( &TANK_FIRE, sizeof( int ), f );
	pack_fread( &TANK_LIFE, sizeof( int ), f );
	pack_fread( &HUMAN_TANK_LIFE, sizeof( int ), f );
	pack_fread( &BULLET_LIFE, sizeof( int ), f );
	pack_fread( &BULLET_SPEED, sizeof( float ), f );
	pack_fread( &NUM_TREES, sizeof( int ), f );

	pack_fclose( f );
}





void do_save_config()
{
	char filename[255];
	sprintf( filename, "./" );
	if ( file_select_ex("Save Config...", filename, "tnk", 255, OLD_FILESEL_WIDTH,OLD_FILESEL_HEIGHT ) )
		save_config( filename );
}

void do_load_config()
{
	char filename[255];
	sprintf( filename, "./" );
	if ( file_select_ex("Load Config...", filename, "tnk", 255, OLD_FILESEL_WIDTH,OLD_FILESEL_HEIGHT ) )
		load_config( filename );
}


void draw_cursor()
{
	draw_sprite( buffer, menu[ CURSOR ].dat, mouse_x, mouse_y );
}

int mouse_over( int x1, int y1, int x2, int y2 )
{
	if ( ( mouse_x > x1 ) && (mouse_x < x2) && (mouse_y > y1) && (mouse_y < y2) )
		return 1;
	else
		return 0;
}



int do_button( int num, int x1, int y1 )
{
	BITMAP *b;
	int retval = 0;
	b = (BITMAP *)menu[ num ].dat;

	if ( ( mouse_x > x1 ) && (mouse_y > y1) && (mouse_x < x1 + (b->w)) && (mouse_y < y1 + (b->h)) )
	{
		draw_sprite( buffer, menu[ num + 1].dat, x1, y1 );
		if ( mouse_b == 1 )
			retval = 1;
		while ( mouse_b == 1 );
	}
	else
		draw_sprite( buffer, menu[ num ].dat, x1, y1 );


	return retval;
}

int do_button_centre( int num, int x1, int y1 )
{
	BITMAP *b;
	int r;
	b = (BITMAP *)menu[num].dat;
	r = do_button( num, x1 - (b->w/2), y1 - (b->h/2) );
	return r;

}



//Controller and Controll Names
char *control_name[ 7 ] = { "Turn Left", "Turn Right", "Move Forwards", "Move Backwards", "Turret Left", "Turret Right", "Shoot" };
char *control_type[ 4 ] = { "Keyboard", "Mouse", "Gamepad / Joystick / Keyboard" };


//Gets the inputs for a specific player(int p)
void get_input( int p )
{
	int ctrl_type = 0;
	int i, n, o;
	int done = 0;

	//Get user to select input type
	while ( !done )
	{
		blit( menu[ BACKGROUND ].dat, buffer, 0, 0, 0, 0, 640, 480 );
		textout_centre( buffer, font, "Choose Control Type", 320, 200, makecol(255,255,255) );
		textout_centre( buffer, font, control_type[ ctrl_type ], 320, 240, makecol(255,255,0 ) );

		if ( do_button( UP, 300, 260 ) )
			ctrl_type--;
		if ( do_button( DOWN, 340, 260 ) )
			ctrl_type++;

		done = do_button( CHECK, 320, 300 );
		if ( ctrl_type > 2 )
			ctrl_type = 0;
		if ( ctrl_type < 0 )
			ctrl_type = 2;

		draw_cursor();
		blit( buffer, screen, 0, 0, 0, 0, 640, 480 );
	}

	player[ p ].input_type = ctrl_type;

	//User has selected an input device,  now do specific
	blit( menu[ BACKGROUND ].dat, screen, 0, 0, 0, 0, 640, 480 );
	if ( ctrl_type == 0 )	//Keyboard
	{
		//Ask for input on all keys
		for (i = 0; i < 7; i++ )
		{
			textout_centre( screen, font, control_name[ i ], 320, (i * 10) + 40, makecol(255,255,255) );
			player[ p ].key[ i ] = readkey() >> 8;
			player[ p ].joy[ i ] = 0;
		}
	}
	else if ( ctrl_type == 1 )	//Mouse
	{
		textout_centre( screen, font, "Turret Controls With Mouse", 320, 40, makecol(255,255,255) );
		//Ask for input on all four tank movements
		for ( i = 0; i < 4; i++ )
		{
			textout_centre( screen, font, control_name[ i ], 320, (i * 10) + 50, makecol(255,255,255) );
			player[ p ].key[ i ] = readkey() >> 8;
		}
	}
	else if ( ctrl_type == 2 )	//Joystick
	{
		do_calibrate_joystick();
	}

	if ( ctrl_type >= 2 )	//Joystick or gamepad
	{
		blit( menu[ BACKGROUND ].dat, buffer, 0, 0, 0, 0, 640, 480 );
		//Get input for every "Key"
		for ( i = 0; i < 7; i++ )
		{
			textout_centre( screen, font, control_name[ i ], 320, (i * 10) + 50, makecol(255,255,255) );
			done = 0;

			//Wait for a key from either joystick or keyboard is pushed
			while ( !done )
			{
				//Check for joystick (or gamepad) activity
				for ( o = 0; poll_joystick_key( o ) || (o <= NUM_JOYSTICK_BUTTONS); o++ );

				//If there was joystick Activity
				if ( o != NUM_JOYSTICK_BUTTONS )
				{
					o--;
					player[ p ].joy[ i ] = 1;
					player[ p ].key[ i ] = o;

					//Wait for key to be "unpushed"
					while ( poll_joystick_key( o ) );
				}

				if ( keypressed() )
				{
					o = readkey() >> 8;

					player[ p ].joy[ i ] = 0;
					player[ p ].key[ i ] = o;
					done = 1;

					//Wait for key to be unpushed
					while ( key[ o ] );
				}
			}
		}
	}
}


void do_control_config()
{
	while ( !key[ KEY_ESC ] )
	{
		blit( menu[ BACKGROUND ].dat, buffer, 0, 0, 0, 0, 640, 480 );
		if ( do_button( PLAYER1, 320, 140 ) )
			get_input( 0 );
		if ( do_button( PLAYER2, 320, 200 ) )
			get_input( 1 );
		if ( do_button( PLAYER3, 320, 260 ) )
			get_input( 2 );
		if ( do_button( PLAYER4, 320, 320 ) )
			get_input( 3 );

		draw_cursor();
		blit( buffer, screen, 0, 0, 0, 0, 640, 480 );

	}
	while ( key[ KEY_ESC ] );
}


void do_options()
{
	while ( !key[ KEY_ESC ] )
	{
		blit( menu[ BACKGROUND ].dat, buffer, 0, 0, 0, 0, 640, 480 );
		draw_sprite( buffer, menu[ TANKIT_LOGO ].dat, 212, 10 );

		textprintf( buffer, font, 50,  80, white, "Arena Width: %i", BOUNDRY_X );
		textprintf( buffer, font, 50, 115, white, "Arena Height: %i", BOUNDRY_Z );
		textprintf( buffer, font, 50, 150, white, "Number Of Tanks: %i", NUM_TANKS );
		textprintf( buffer, font, 50, 185, white, "Tank Speed: %f", TANK_SPEED );
		textprintf( buffer, font, 50, 220, white, "Tank Rotation Speed: %f", ROTATE_SPEED );
		textprintf( buffer, font, 50, 255, white, "Tank Fire Speed: %i", TANK_FIRE);
		textprintf( buffer, font, 50, 290, white, "Normal Tank Life: %i", TANK_LIFE);
		textprintf( buffer, font, 50, 325, white, "Human Tank Life: %i", HUMAN_TANK_LIFE);
		textprintf( buffer, font, 50, 360, white, "Bullet Life: %i", BULLET_LIFE );
		textprintf( buffer, font, 50, 395, white, "Bullet Speed: %f", BULLET_SPEED );
		textprintf( buffer, font, 50, 430, white, "Number Of Trees: %i", NUM_TREES );

		if ( do_button( UP, 320, 	70 ) )		BOUNDRY_X += 5;
		if ( do_button( DOWN, 360, 70 ) )		BOUNDRY_X -= 5;

		if ( do_button( UP, 320,	105 ) )		BOUNDRY_Z += 5;
		if ( do_button( DOWN, 360, 105 ) )		BOUNDRY_Z -= 5;

		if ( do_button( UP, 320,	140 ) )		NUM_TANKS += 1;
		if ( do_button( DOWN, 360, 140 ) )		NUM_TANKS -= 1;

		if ( do_button( UP, 320,	175 ) )		TANK_SPEED += 0.05;
		if ( do_button( DOWN, 360, 175 ) )		TANK_SPEED -= 0.05;

		if ( do_button( UP, 320,	210 ) )		ROTATE_SPEED += 0.05;
		if ( do_button( DOWN, 360, 210 ) )		ROTATE_SPEED -= 0.05;

		if ( do_button( UP, 320,	245 ) )		TANK_FIRE += 1;
		if ( do_button( DOWN, 360, 245 ) )		TANK_FIRE -= 1;

		if ( do_button( UP, 320,	280 ) )		TANK_LIFE += 1;
		if ( do_button( DOWN, 360, 280 ) )		TANK_LIFE -= 1;

		if ( do_button( UP, 320,	315 ) )		HUMAN_TANK_LIFE += 1;
		if ( do_button( DOWN, 360, 315 ) )		HUMAN_TANK_LIFE -= 1;

		if ( do_button( UP, 320,	350 ) )		BULLET_LIFE += 5;
		if ( do_button( DOWN, 360, 350 ) )		BULLET_LIFE -= 5;

		if ( do_button( UP, 320,	385 ) )		BULLET_SPEED += 0.1;
		if ( do_button( DOWN, 360, 385 ) )		BULLET_SPEED -= 0.1;

		if ( do_button( UP, 320,	420 ) )		NUM_TREES += 5;
		if ( do_button( DOWN, 360,	420 ) )		NUM_TREES -= 5;

		if ( do_button( CONTROLS, 450, 240 ) )	do_control_config();

		if ( do_button( SAVE, 450, 70 ) ) do_save_config();
		if ( do_button( LOAD, 450, 105) ) do_load_config();

		//Limit Numbers
		if ( BOUNDRY_X < 10 )			BOUNDRY_X = 10;
		if ( BOUNDRY_Z < 10 )			BOUNDRY_Z = 10;
		if ( NUM_TANKS < 3 )				NUM_TANKS = 3;
		if ( NUM_TANKS > MAX_TANKS )	NUM_TANKS = MAX_TANKS;
		if ( TANK_SPEED <= 0.1)			TANK_SPEED = 0.1;
		if ( ROTATE_SPEED <= 0.1)		ROTATE_SPEED = 0.1;
		if ( TANK_LIFE <= 1 )			TANK_LIFE = 1;
		if ( HUMAN_TANK_LIFE <= 1 )	HUMAN_TANK_LIFE = 1;
		if ( BULLET_LIFE <= 5 )			BULLET_LIFE = 5;
		if ( BULLET_SPEED <= 0.1 )		BULLET_SPEED = 0.1;
		if ( NUM_TREES <= 0 )			NUM_TREES = 0;
		if ( NUM_TREES >= MAX_TREES)	NUM_TREES = MAX_TREES;

		draw_cursor();
		blit( buffer, screen, 0, 0, 0, 0, 640, 480 );

	}
}

void do_exit()
{
	save_controls();

	unload_datafile( sound );
	allegro_exit();
	exit( 0 );
}

void start_game_menu()
{
	int game_done = 0;
	while ( !game_done )
	{
		blit( menu[ BACKGROUND ].dat, buffer, 0, 0, 0, 0, 640, 480 );
		draw_sprite( buffer, menu[ TANKIT_LOGO ].dat, 212, 10 );

		if ( do_button( PLAYER1, 320, 165 ) )
		{
			start_game( 0 );
			game_done = 1;
		}

		if ( do_button( PLAYER2, 320, 202 ) )
		{
			start_game( 1 );
			game_done = 1;
		}

		if ( do_button( PLAYER3, 320, 239 ) )
		{
			start_game( 2 );
			game_done = 1;
		}

		if ( do_button( PLAYER4, 320, 276 ) )
		{
			start_game( 3 );
			game_done = 1;
		}

		draw_cursor();
		blit( buffer, screen, 0, 0, 0, 0, 640, 480 );
	}
}

void do_main_menu()
{
	buffer = create_bitmap( 640, 480 );


	while ( 1 )
	{
		blit( menu[ BACKGROUND ].dat, buffer, 0, 0, 0, 0, 640, 480 );
		draw_sprite( buffer, menu[ TANKIT_LOGO ].dat, 212, 10 );

		if ( do_button_centre( START_GAME, 	320, 165  ) )
			start_game_menu();

		if ( do_button_centre( OPTIONS, 		320, 215  ) )
			do_options();

		if ( do_button_centre( EXIT, 			320, 260  ) )
			do_exit();

		draw_cursor();
		blit( buffer, screen, 0, 0, 0, 0, 640, 480 );
	}

}


int main( void )
{
	allegro_init();
	install_keyboard();
	install_timer();
	install_mouse();

	set_color_depth( 16 );
	if ( set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0 ) < 0 )
	{
		printf( "Couldn't Init Graphics\n");
		exit( -1 );
	}
	text_mode( -1 );

	//Install Sound
	if ( detect_digi_driver( DIGI_AUTODETECT ) )
	{
			reserve_voices( 8, 0 );
			install_sound( DIGI_AUTODETECT, MIDI_NONE, "" );
	}

	load_controls();

	srand( time( 0 ) );
	sound = load_datafile( "sounds.dat" );
	menu = load_datafile( "menus.dat" );

	white = makecol( 255, 255, 255 );

	do_main_menu();


	allegro_exit();
} END_OF_MAIN();

