int BOUNDRY_X 					= 150;
int BOUNDRY_Z 					= 150;

#define MAX_TREES				500
int NUM_TREES					= 200;
#define MAX_TANKS				500
int NUM_TANKS 					= 50;

float TANK_SPEED				= 0.2;
float ROTATE_SPEED			= 2.0;
int TANK_FIRE					= 50;
int TANK_LIFE					= 3;
int HUMAN_TANK_LIFE			= 6;

#define TURRET_SPEED			2.5
#define HIT_RADIUS			2

#define MAX_BULLETS			500
int BULLET_LIFE				= 50;
float BULLET_SPEED			= 1.0;

#define TURRET_BOUNCING 	0.5
#define TURRET_RECON			0.03

#define CAMERA_ZOOM			50
#define CAMERA_DISTANCE		10
#define CAMERA_Y_DISTANCE	12
#define CAMERA_RX				10

#define SEEING_DISTANCE		100
#define HEARING_DISTANCE	75

#define GROUND_Y				-11
#define TANK_Y					-11
#define BULLET_Y				-9.5

#define MAX_PARTICLE			10000
#define PART_LIFE				100
#define PART_LIFE_VARIANCE	50
#define GRAVITY				0.098

#define PI						3.141592654

#define AI_TURN_LEFT_PERCENT		60
#define AI_SHOOT_DISTANCE			30

//Bullet Struct
typedef struct BULLETTYPE
{
	float x, y, z;
	float vx, vz;
	int life;
} BULLETTYPE;

//Tank Struct
typedef struct TANKTYPE
{
	float x, y, z;
	float vx, vz;
	float angle;
	float turret_angle;

	float turret_x, turret_z;
	float turret_bounce;	//How far back the turret has bounced

	int fire;			//How long until tank can fire next bullet
	int life;

	int found_target;	//For AI  (what the tanks current target it )
} TANKTYPE;

typedef struct PARTICLETYPE
{
	float x, y, z;				//Position Vector
	float vx, vy, vz;			//Position Velocity Vector

	float rx, ry, rz;			//Rotation Vector
	float vrx, vry, vrz;		//Rotation Velocities Vector

	float r, g, b;
	int life;
} PARTICLETYPE;

typedef struct CAMERATYPE
{
		float rx, ry, rz;
		float x, y, z;
} CAMERATYPE;


typedef struct TREETYPE
{
	int x, z;
} TREETYPE;
int tanks_left;
int num_humans;

typedef struct PLAYERTYPE
{
	int input_type;	//What Type of Input the player uses
							//See "Controllers and Controll Names" in main.c ~(line 152)
	int key[ 7 ];		//Keyboard Values #0-255 for input
	int joy[ 7 ];		//Joystick Values
} PLAYERTYPE;


DATAFILE *sound;
PLAYERTYPE player[ 4 ];
CAMERATYPE camera[ 4 ];
PARTICLETYPE particle[ MAX_PARTICLE ];
TANKTYPE tank[ MAX_TANKS ];
BULLETTYPE bullet[ MAX_BULLETS ];
TREETYPE tree[ MAX_TREES ];

